***********************
*Time Series Analysis for the Social Sciences
*Box-Steffensmeier, Freeman, Hitt, and Pevehouse
*
*Appendix replication code
************************

************************
*Figure A.1 
*Use DurrGilmourWolbrecht_cong_econ.dta
*Source: Durr, Gilmour, and Wolbrecht 1997
*************************

line capp qdate, yaxis(1) yscale(range(50 80) axis(1)) /// 
|| line econexp qdate, scheme(s1mono) yaxis(2) yscale(range(50 100) axis(2)) ///
title(U.S. Congressional Approval and Economic Expectations)

**************************
*Figures A.2-A.5
*Use appendix_figures_1.dta
*Source: simulated, see Appendix simulated data.r
**************************

tsset time

*Figure A.2

tsline figA2

*Figure A.3 

tsline figA3

*Figure A.4

tsline figA4

*Figure A.5

tsline figA5_0 || tsline figA5_1 || tsline figA5_100

*****************************
*Figure A.6
*Use appendix_figures_2.dta
*Source: simulated, see Appendix simulated data.r
**************************

tsset time_2

tsline draw_1 || tsline draw_2

*****************************
*Figure A.7
*Use appendix_figures_3.dta
*Source: simulated, see Appendix simulated data.r
**************************

line A7_Series_1 A7_Series_2, xscale(range(50(50)350)) xlabel(50(50)350)

*****************************
*Figure A.8
*Use appendix_figures_4.dta
*Source: simulated, see Appendix simulated data.r
**************************

tsset time_4

tsline draw_1_trend || tsline draw_2_trend

*****************************
*Figures A.9-A.12
*Use appendix_figures_5.dta
*Source: simulated, see Appendix simulated data.r
**************************

tsset time_5

*Figure A.9

tsline figA9 if time_5 <11

*Figure A.10

tsline figA10

*Figure A.11

tsline figA11 if time_5 < 11

*Figure A.12

tsline figA12

*****************************
*Figure A.13
*Use appendix_figures_6.dta
*Source: simulated, see Appendix simulated data.r
**************************

tsset time_6

tsline figA13_1 || tsline figA13_2 || tsline figA13_3 || tsline figA13_4 || tsline figA13_5 
