# Simulate some time series data using the arima.sim procedure and plot the resulting data
set.seed(123456)
y <- arima.sim(n = 1000, list(order=c(1,0,0), ar = .9), innov=rnorm(1000))
plot.ts(y, ylab='')

# Plot the series and its autocorrelation function

op <- par(no.readonly=TRUE)
layout(matrix(c(1, 1, 2, 3), 2, 2, byrow=TRUE))
plot.ts(y, ylab='')
acf(y, main='Autocorrelations', ylab='',
    ylim=c(-1, 1), ci.col = "black")
pacf(y, main='Partial Autocorrelations', ylab='',
     ylim=c(-1, 1), ci.col = "black")
par(op)
