library(TSA)
# Data from Whittaker and Robinson on brightness (amplitude) of a particular star at midnight on 600 consecutive
# nights
data(star)
plot(star,xlab='Day',ylab='Brightness',main='Time Series')

#Computing and Plotting the Periodogram and Spectrum Using TSA
# Raw Periodogram without connecting lines
periodogram(star,ylab='Variable Star Periodogram',main='Raw Periodogram');  abline(h=0)

# Various spectra with smoothing and tapering
par(mfrow=c(3,1))
sp=spec(star,sub='',main='Unsmoothed Spectrum',spans=NULL, log="no")
sp=spec(star,sub='',main='Smoothed Spectrum', spans=3, ci.plot=TRUE, log="no")
sp=spec(star,sub='',main='More Smoothed Spectrum',spans=5, ci.plot=TRUE, log="no")

# Using the base package
par(mfrow=c(3,1))
spectrum(star, log=c("no"))
spectrum(star, spans=3, log=c("no"))
spectrum(star, spans=5, log=c("no"), main="More Smoothed Periodogram")

# Both "spec" and "spectrum" are calls to the stats package procedure spec.pgram. The full set of options is below
spec.pgram(star, spans = NULL, kernel("daniell",1), log=c("no"),taper=0.1,
           pad = 0, fast = TRUE, demean = FALSE, detrend = TRUE,
           plot = TRUE, na.action = na.fail)

